// Copyright (c) 2017, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/*element: main:[null]*/
main() {
  yieldZero();
  yieldList();
  yieldStarList();
  yieldMany();
  yieldIntAndString();
}

////////////////////////////////////////////////////////////////////////////////
// Yield a single integer.
////////////////////////////////////////////////////////////////////////////////

/*element: yieldZero:[exact=_SyncStarIterable]*/
yieldZero() sync* {
  yield 0;
}

////////////////////////////////////////////////////////////////////////////////
// Yield a list of integers.
////////////////////////////////////////////////////////////////////////////////

/*element: yieldList:[exact=_SyncStarIterable]*/
yieldList() sync* {
  yield [0, 1, 2, 3];
}

////////////////////////////////////////////////////////////////////////////////
// Yield star of a list of integers.
////////////////////////////////////////////////////////////////////////////////

/*element: yieldStarList:[exact=_SyncStarIterable]*/
yieldStarList() sync* {
  yield* [0, 1, 2, 3];
}

////////////////////////////////////////////////////////////////////////////////
// Yield multiple integers.
////////////////////////////////////////////////////////////////////////////////

/*element: yieldMany:[exact=_SyncStarIterable]*/
yieldMany() sync* {
  yield 0;
  yield 1;
  yield 2;
  yield 3;
}

////////////////////////////////////////////////////////////////////////////////
// Yield an integer and a string.
////////////////////////////////////////////////////////////////////////////////

/*element: yieldIntAndString:[exact=_SyncStarIterable]*/
yieldIntAndString() sync* {
  yield 0;
  yield '';
}
